#pragma once

#include <array>
#include <string_view>

namespace faker::plant
{
const auto trees = std::to_array<std::string_view>({
    "Oak",          "Maple",     "Pine",    "Birch",        "Willow",       "Cherry Blossom",
    "Cypress",      "Palm",      "Redwood", "Dogwood",      "Ash",          "Cedar",
    "Fir",          "Poplar",    "Beech",   "Eucalyptus",   "Juniper",      "Sycamore",
    "Hemlock",      "Spruce",    "Mango",   "Apple",        "Orange",       "Lemon",
    "Avocado",      "Almond",    "Walnut",  "Chestnut",     "Bamboo",       "Papaya",
    "Peach",        "Pineapple", "Banana",  "Acacia",       "Hickory",      "Cottonwood",
    "Baobab",       "Catalpa",   "Ginkgo",  "Chestnut Oak", "Black Walnut", "Japanese Maple",
    "Crape Myrtle", "Kapok",     "Mimosa",  "Linden",       "Tamarind",
});

const auto flowers = std::to_array<std::string_view>({
    "Rose",
    "Chrysanthemum",
    "Daisy",
    "Jasmine",
    "Gerbera",
    "Carnation",
    "Poppy",
    "Tulip",
    "Lily",
    "Lotus",
    "Hibiscus",
    "Peony",
    "Sunflower",
    "Lilac",
    "Aster",
    "Dandelion",
    "Marigold",
    "Dahlia",
    "Lamium",
    "Datura",
    "Cosmos",
    "Broom",
    "Columbine",
    "Cassia Fistula",
    "Water Lily",
    "Pansy",
    "Plumeria",
    "Adenium Obesum",
    "Amaranthus",
    "Viola",
    "Allamanda Cathartica",
    "Hedera Helix",
    "False indigo",
    "Feverfew",
    "Dwarf Morning Glory",
    "Mogra",
    "Bird-of-paradise",
    "Palash",
    "Phoenix Flower",
    "Cherry Blossom",
    "Geranium",
    "Purple Giant Hyssop",
    "Orchid",
    "Fiesta Daisy",
    "Anthurium",
    "Goldenrod",
    "Daffodils",
    "Gladiolus",
    "Feather Flower",
    "False Salvia",
    "Elderberry",
    "Evening Primrose",
    "Foxglove",
    "Fairy Candles",
    "Elephant Ear Flower",
    "Moonflower",
    "White Baneberry",
    "Forget-me-not",
    "Pipevine",
    "Petunia",
    "Zinnia",
    "Larkspur",
    "Calendula",
    "Snapdragon",
    "Impatiens",
    "Vinca",
    "Begonia",
    "Cornflower",
    "Celosia",
    "Primrose",
    "Kale",
    "African Daisy",
    "Peruvian Daylily",
    "Dropmore Flower",
    "False Spirea",
    "Prince’s Feather",
    "Graceland",
    "Fairy Iris",
    "Gentian Violet",
    "Gardenia",
    "Baby’s breath",
    "Lantana",
    "Mallow",
    "Lavender",
    "Queen Anne’s Lace",
    "Speedwell",
    "Sweet William",
    "Black-eyed Susans",
    "Hollyhocks",
    "Caraway Herb",
    "Angelica",
    "Canterbury Bells",
});

const auto shrubs = std::to_array<std::string_view>({
                                                     "Aralia",        "Arctostaphylos", "Aronia",
                                                     "Artemisia",     "Aucuba",         "Berberis",
                                                     "Bougainvillea", "Brugmansia",     "Buddleja",
                                                     "Buxus",         "Calia",          "Callicarpa",
                                                     "Callistemon",   "Calluna",        "Calycanthus",
                                                     "Camellia",      "Caragana",       "Carpenteria",
                                                     "Caryopteris",   "Cassiope",       "Ceanothus",
                                                     "Celastrus",     "Ceratostigma",   "Cercocarpus",
                                                     "Chaenomeles",   "Chamaebatiaria", "Chamaedaphne",
                                                     "Chimonanthus",  "Chionanthus",    "Choisya",
                                                     "Cistus",        "Clerodendrum",   "Clethra",
                                                     "Clianthus",     "Colletia",       "Colutea",
                                                     "Comptonia",     "Cornus",         "Corylopsis",
                                                     "Cotinus",       "Cotoneaster",    "Cowania",
                                                     "Crataegus",     "Crinodendron",   "Cytisus",
                                                     "Daboecia",      "Danae",          "Daphne",
                                                     "Decaisnea",     "Dasiphora",      "Dendromecon",
                                                     "Desfontainea",  "Deutzia",        "Diervilla",
                                                     "Dipelta",       "Dirca",          "Dracaena",
                                                     "Drimys",        "Dryas",          "Elaeagnus",
                                                     "Embothrium",    "Empetrum",       "Enkianthus",
                                                     "Ephedra",       "Epigaea",        "Erica",
                                                     "Eriobotrya",    "Escallonia",     "Eucryphia",
                                                     "Euonymus",      "Exochorda",      "Fabiana",
                                                     "Fallugia",      "Fatsia",         "Forsythia",
                                                     "Fothergilla",   "Franklinia",     "Fremontodendron",
                                                     "Fuchsia",       "Garrya",         "Gaultheria",
                                                     "Gaylussacia",   "Genista",        "Gordonia",
                                                     "Grevillea",     "Griselinia",     "Hakea",
                                                     "Halesia",       "Halimium",       "Hamamelis",
                                                     "Hebe",          "Hedera",         "Helianthemum",
                                                     "Hibiscus",      "Hippophae",      "Hoheria",
                                                     "Holodiscus",    "Hudsonia",       "Hydrangea",
                                                     "Hypericum",     "Hyssopus",       "Ilex",
                                                     "Illicium",      "Indigofera",     "Itea",
                                                     "Jamesia",       "Jasminum",       "Juniperus",
                                                     "Kalmia",        "Kerria",         "Kolkwitzia",
                                                     "Lagerstroemia", "Lapageria",      "Lantana",
                                                     "Lavandula",     "Lavatera",       "Ledum",
                                                     "Leitneria",     "Lespedeza",      "Leptospermum",
                                                     "Leucothoe",     "Leycesteria",    "Ligustrum",
                                                     "Lindera",       "Linnaea",        "Lonicera",
                                                     "Lupinus",       "Lycium",         "Magnolia",
                                                     "Mahonia",       "Malpighia",      "Menispermum",
                                                     "Menziesia",     "Mespilus",       "Microcachrys",
                                                     "Myrica",        "Myricaria",      "Myrtus",
                                                     "Neillia",       "Nerium",         "Olearia",
                                                     "Osmanthus",     "Pachysandra",    "Paeonia",
                                                     "Perovskia",     "Philadelphus",   "Phlomis",
                                                     "Photinia",      "Physocarpus",    "Pieris",
                                                     "Pistacia",      "Pittosporum",    "Plumbago",
                                                     "Polygala",      "Poncirus",       "Prunus",
                                                     "Purshia",       "Pyracantha",     "Quassia",
                                                     "Quercus",       "Quillaja",       "Quintinia",
                                                     "Rhamnus",       "Rhododendron",   "Rhus",
                                                     "Ribes",         "Romneya",        "Rosa",
                                                     "Rosmarinus",    "Rubus",          "Ruta",
                                                     "Sabia",         "Salix",          "Salvia",
                                                     "Sambucus",      "Santolina",      "Sapindus",
                                                     "Senecio",       "Simmondsia",     "Skimmia",
                                                     "Smilax",        "Sophora",        "Sorbaria",
                                                     "Spartium",      "Spiraea",        "Staphylea",
                                                     "Stephanandra",  "Styrax",         "Symphoricarpos",
                                                     "Syringa",       "Tamarix",        "Taxus",
                                                     "Telopea",       "Thymelaea",      "Thymus",
                                                     "Trochodendron", "Ulex",           "Ungnadia",
                                                     "Vaccinium",     "Verbena",        "Viburnum",
                                                     "Vinca",         "Viscum",         "Weigela",
                                                     "Xanthoceras",   "Xanthorhiza",    "Xylosma",
                                                     "Yucca",         "Zanthoxylum",    "Zauschneria",
    "Zenobia",       "Ziziphus"
});

const auto grasses = std::to_array<std::string_view>({
    "Rye",
    "Miscanthus",
    "Oat",
    "Sorghum",
    "Wheat",
    "Maize (Corn)",
    "Bamboo",
    "Sugarcane",
    "Sudan",
    "Switchgrass",
    "Bahiagrass",
    "Pangola",
    "Para",
    "Guinea",
    "Natal",
    "Napier",
    "Foxtail Millet",
    "Barnyard",
    "Crab",
    "Johnsongrass",
    "Vasey",
    "Dallis",
    "Purpletop",
    "Redtop",
    "Switchgrass",
    "Indiangrass",
    "Big Bluestem",
    "Little Bluestem",
    "Yellow Indiangrass",
    "Eastern Gamagrass",
    "Side-Oats Grama",
    "Blue Grama",
    "Plains Love",
    "Weeping Love",
    "Purple Love",
    "Reed Canary",
    "Timothy",
    "Miscanthus",
    "Oat",
    "Sorghum",
    "Wheat",
    "Maize (Corn)",
    "Bamboo",
    "Sugarcane",
    "Sudan",
    "Switchgrass",
    "Bahiagrass",
    "Pangola",
    "Para",
    "Guinea",
    "Velvet",
    "Meadow Foxtail",
    "Marsh Foxtail",
    "Green Foxtail",
    "Yellow Foxtail",
    "Bottlebrush",
    "Muhly",
    "Deer",
    "Hair",
    "Bluejoint Reed",
    "Northern Reed",
    "Canada Wild Rye",
    "Virginia Wild Rye",
    "Streambank Wheat",
    "Thickspike Wheat",
    "Beardless Wheat",
    "Intermediate Wheat",
    "Siberian Wheat",
    "Russian Wildrye",
    "Bluebunch Wheat",
    "Western Wheat",
    "Creeping Wildrye",
    "Basin Wildrye",
    "Sand Dropseed",
    "Sand Love",
    "Sandreed",
    "Bottlebrush Love",
    "Redtop Love",
    "Fall Witchgrass",
    "Witchgrass",
    "Ditch Witchgrass",
    "Scribner Panic",
    "Hall's Panic",
    "Torpedo",
    "Browntop Panic",
    "Kleingrass",
    "Vasey",
    "Vine Mesquite",
    "Scribner Cane",
    "Giant Reed",
    "Ravenna",
    "Pampas",
    "Flowering Reed",
    "Fountain",
    "Bush Muhly",
    "Pink Muhly",
    "Muhly",
});

const auto ferns = std::to_array<std::string_view>({
    "Horsetails",
    "Ostrich Fern",
    "Eagle Fern",
    "Leatherleaf Fern",
    "Leptochilus pteropus",
    "Diplazium esculentum",
    "Royal Fern",
    "Polypodiophyta",
    "Tree Ferns",
    "Male Fern",
    "Leptosporangiate Ferns",
    "Equisetidae",
    "Psilotum",
    "Licorice Fern",
    "Brake Family",
    "Angiopteris evecta",
    "Pteris vittata",
    "Giant Salvinia",
    "Polypodiopsida",
    "Marattiaceae",
    "Ophioglossales",
    "Sphaeropteris cooperi",
    "Cladoxylopsida",
    "Zygopteridales",
    "Maidenhair Fern",
    "Boston Fern",
    "Bird's-nest Fern",
    "Staghorn Fern",
    "Silver Fern",
    "Hart's-tongue Fern",
    "Lady Fern",
    "Japanese Painted Fern",
    "Button Fern",
    "Sword Fern",
    "Bracken Fern",
    "Christmas Fern",
    "Cinnamon Fern",
    "Polypody Fern",
    "Maidenhair Spleenwort",
    "Walking Fern",
    "Oak Fern",
    "Holly Fern",
    "Leather Fern",
    "Maidenhair Tree Fern",
    "Blechnum Fern",
    "Wood Fern",
    "Sensitive Fern",
    "Chain Fern",
    "Water Fern",
    "Beech Fern",
    "Cliff Fern",
    "Sword Brake",
    "Tassel Fern",
    "Hay-Scented Fern",
    "Resurrection Fern",
    "Adder's-tongue Fern",
    "Grape Fern",
    "Bladder Fern",
    "Brittle Fern",
    "Cliff Brake",
    "Deer Fern",
    "Diamond Fern",
    "Filmy Fern",
    "Fox Fern",
    "Ground Fern",
    "Hairy Spleenwort",
    "Lace Fern",
    "Leathery Polypody",
    "Lip Fern",
    "Marsh Fern",
    "Moonwort",
    "Mosquito Fern",
    "Parsley Fern",
    "Rattlesnake Fern",
    "Rock Fern",
    "Running Fern",
    "Rusty Sword Fern",
    "Shield Fern",
    "Shuttle Fern",
    "Silver Sword Fern",
    "Spleenwort",
    "Stag Horn Fern",
    "Tongue Fern",
    "Wooly Fern",
});

const auto succulents = std::to_array<std::string_view>({
    "Cactus",
    "Jade Plant",
    "Burro's-tail",
    "Echeveria elegans",
    "Dracaena trifasciata",
    "Fasciated haworthia",
    "Portulacaria afra",
    "Zanzibar Gem",
    "Radiator Plants",
    "Haworth's aeonium",
    "Begonia",
    "Cyphostemma",
    "Asparagus",
    "Crown-of-thorns",
    "Moth Orchids",
    "Asphodelaceae",
    "Jovibarba heuffelii",
    "Scadoxus",
    "Touch-me-not",
    "Strumaria",
    "Fouquieria",
    "Brighamia",
    "Cyrtanthus",
    "Nerine",
    "Dioscorea",
    "Wood Sorrels",
    "Zephyrlily",
    "Pokeweeds",
    "Grass Trees",
    "Haemanthus",
    "Crinum",
    "Hypoxis",
    "Medinilla",
    "Pancratium",
    "Cryptolepis",
    "Basella",
    "Habranthus",
    "Nolana",
    "Brunsvigia",
    "Lentibulariaceae",
    "Empodium",
    "Doryanthes",
    "Gethyllis",
    "Boophone",
    "Cussonia",
    "Rauhia",
    "Anredera",
    "Sarcostemma",
    "Matelea",
    "Ammocharis",
    "Hessea",
    "Aloe vera",
    "Sempervivum (Hen and Chicks)",
    "Haworthia",
    "Gasteria",
    "Sedum (Stonecrop)",
    "Othonna (Little Pickles)",
    "Graptopetalum (Ghost Plant)",
    "Crassula (Jade Plant)",
    "Kalanchoe (Flaming Katy, Kalanchoe Blossoms)",
    "Aeonium",
    "Graptopetalum amethystinum",
    "Avonia",
    "Dudleya",
    "Echeveria agavoides",
    "Echeveria blue echeveria",
    "Echeveria derenbergii",
    "Echeveria gibbiflora",
    "Echeveria harmsii",
    "Echeveria lilacina",
    "Echeveria nodulosa",
    "Echeveria peacockii",
    "Echeveria pulidonis",
    "Echeveria purpusorum",
    "Echeveria setosa",
    "Echeveria shaviana",
    "Echeveria subrigida",
    "Espostoa",
    "Faucaria",
    "Fenestraria",
    "Gasteria carinata",
    "Gasteria batesiana",
    "Gasteria vlokii",
    "Graptopetalum paraguayensis",
    "Greenovia",
    "Haworthia attenuata",
    "Haworthia cooperi",
    "Haworthia cymbiformis",
    "Haworthia fasciata",
    "Haworthia graminifolia",
    "Haworthia obtusa",
    "Haworthia reinwardtii",
    "Haworthia truncata",
    "Huernia",
    "Hylocereus",
    "Kleinia",
    "Lampranthus",
    "Ledebouria",
    "Lithops",
    "Mammillaria",
    "Muiraquilocactus",
    "Notocactus",
    "Obregonia",
    "Opuntia",
    "Orbea",
    "Pachycereus",
    "Parodia",
    "Pelecyphora",
    "Pereskiopsis",
    "Pleiospilos",
    "Rebutia",
    "Rhodocactus",
    "Roseocactus",
    "Schlumbergera (Christmas Cactus)",
    "Senecio",
    "Senecio haworthii",
    "Senecio mandraliscae",
    "Senecio rowleyanus (String of Pearls)",
    "Sinocrassula",
    "Sophora",
    "Stapelia",
    "Stenocactus",
    "Strombocactus",
    "Thelocactus",
    "Titanopsis",
    "Trichocereus",
    "Turbinicarpus",
    "Tylecodon",
    "Uebelmannia",
    "Wilcoxia",
    "Xerosicyos",
});

const auto vines = std::to_array<std::string_view>({
    "Bougainvillea",
    "Clematis",
    "Wisteria",
    "Climbing Hydrangea",
    "Rocktrumpet",
    "Honeysuckle",
    "Creeping Fig",
    "Asparagus asparagoides (Sprenger's Asparagus)",
    "Carolina Jessamine",
    "Chocolate Vine (Akebia quinata)",
    "Morning Glory",
    "Passionflower",
    "Black-eyed Susan Vine (Thunbergia alata)",
    "Akebia (Five-leaf Akebia)",
    "Trumpet Vine",
    "Climbing Rose",
    "Firecracker Vine (Mina lobata)",
    "Hoya carnosa (Wax Plant)",
    "Hyacinth Bean",
    "Jasminum nitidum (Winter Jasmine)",
    "Swiss Cheese Plant",
    "Moonflower",
    "Star Jasmine",
    "Virginia Creeper",
});

const auto plantTypes = std::to_array<std::string_view>({"tree", "flower", "shrub", "grass", "fern", "succulent", "vine"});

}
